/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the ContactEditable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactEditable{}

// ContactEditable struct for ContactEditable
type ContactEditable struct {
	// Profile name. Contacts created automatically out of conversations have messenger profile name here
	Name string `json:"name"`
	// Contact timezone in IANA format
	Timezone *string `json:"timezone,omitempty"`
	// Mobile number in E.164 format
	Mobile *string `json:"mobile,omitempty"`
	// NOT EDITABLE VIA API  Flag to mark mobile number as verified
	MobileVerified *bool `json:"mobile_verified,omitempty"`
	FirstName *string `json:"first_name,omitempty"`
	LastName *string `json:"last_name,omitempty"`
	Email *string `json:"email,omitempty"`
	Gender *string `json:"gender,omitempty"`
	Title *string `json:"title,omitempty"`
	Formal *bool `json:"formal,omitempty"`
	// Birthdate in format specified in organization settings. Default is yyyy-mm-dd
	Birthdate *string `json:"birthdate,omitempty"`
	// Overriden with birthdate data if provided
	DayOfBirth *int32 `json:"day_of_birth,omitempty"`
	// Overriden with birthdate data if provided
	MonthOfBirth *int32 `json:"month_of_birth,omitempty"`
	Address *ContactAddress `json:"address,omitempty"`
	// NOT EDITABLE VIA API  Stores current loyalty points of a contact. Format [providerName_projectId]: [pointsAmount] }
	LoyaltyPoints *map[string]int32 `json:"loyalty_points,omitempty"`
	// NOT EDITABLE VIA API  Stores lifetime loyalty points of a contact. Format { [providerName_projectId]: [pointsAmount] }
	LifetimeLoyaltyPoints *map[string]int32 `json:"lifetime_loyalty_points,omitempty"`
	// JSON with custom properties as defined in organization settings. Format: { [propertyName]: { type: [string|float|bool|date|datetime], value: [propertyValue] } }
	StrictAttributes *map[string]ContactStrictAttribute `json:"strict_attributes,omitempty"`
	CareOf *string `json:"care_of,omitempty"`
	Avatars *ContactAvatars `json:"avatars,omitempty"`
	Languages *ContactLanguages `json:"languages,omitempty"`
	// NOT EDITABLE VIA API 
	MobileVerifiedAt *time.Time `json:"mobile_verified_at,omitempty"`
	// NOT EDITABLE VIA API
	ExternalIds map[string]interface{} `json:"external_ids,omitempty"`
	ErConfidence *ContactERConfidence `json:"er_confidence,omitempty"`
}

// NewContactEditable instantiates a new ContactEditable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactEditable(name string) *ContactEditable {
	this := ContactEditable{}
	this.Name = name
	return &this
}

// NewContactEditableWithDefaults instantiates a new ContactEditable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactEditableWithDefaults() *ContactEditable {
	this := ContactEditable{}
	return &this
}

// GetName returns the Name field value
func (o *ContactEditable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ContactEditable) SetName(v string) {
	o.Name = v
}

// GetTimezone returns the Timezone field value if set, zero value otherwise.
func (o *ContactEditable) GetTimezone() string {
	if o == nil || IsNil(o.Timezone) {
		var ret string
		return ret
	}
	return *o.Timezone
}

// GetTimezoneOk returns a tuple with the Timezone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetTimezoneOk() (*string, bool) {
	if o == nil || IsNil(o.Timezone) {
		return nil, false
	}
	return o.Timezone, true
}

// HasTimezone returns a boolean if a field has been set.
func (o *ContactEditable) HasTimezone() bool {
	if o != nil && !IsNil(o.Timezone) {
		return true
	}

	return false
}

// SetTimezone gets a reference to the given string and assigns it to the Timezone field.
func (o *ContactEditable) SetTimezone(v string) {
	o.Timezone = &v
}

// GetMobile returns the Mobile field value if set, zero value otherwise.
func (o *ContactEditable) GetMobile() string {
	if o == nil || IsNil(o.Mobile) {
		var ret string
		return ret
	}
	return *o.Mobile
}

// GetMobileOk returns a tuple with the Mobile field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetMobileOk() (*string, bool) {
	if o == nil || IsNil(o.Mobile) {
		return nil, false
	}
	return o.Mobile, true
}

// HasMobile returns a boolean if a field has been set.
func (o *ContactEditable) HasMobile() bool {
	if o != nil && !IsNil(o.Mobile) {
		return true
	}

	return false
}

// SetMobile gets a reference to the given string and assigns it to the Mobile field.
func (o *ContactEditable) SetMobile(v string) {
	o.Mobile = &v
}

// GetMobileVerified returns the MobileVerified field value if set, zero value otherwise.
func (o *ContactEditable) GetMobileVerified() bool {
	if o == nil || IsNil(o.MobileVerified) {
		var ret bool
		return ret
	}
	return *o.MobileVerified
}

// GetMobileVerifiedOk returns a tuple with the MobileVerified field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetMobileVerifiedOk() (*bool, bool) {
	if o == nil || IsNil(o.MobileVerified) {
		return nil, false
	}
	return o.MobileVerified, true
}

// HasMobileVerified returns a boolean if a field has been set.
func (o *ContactEditable) HasMobileVerified() bool {
	if o != nil && !IsNil(o.MobileVerified) {
		return true
	}

	return false
}

// SetMobileVerified gets a reference to the given bool and assigns it to the MobileVerified field.
func (o *ContactEditable) SetMobileVerified(v bool) {
	o.MobileVerified = &v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *ContactEditable) GetFirstName() string {
	if o == nil || IsNil(o.FirstName) {
		var ret string
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetFirstNameOk() (*string, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *ContactEditable) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given string and assigns it to the FirstName field.
func (o *ContactEditable) SetFirstName(v string) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *ContactEditable) GetLastName() string {
	if o == nil || IsNil(o.LastName) {
		var ret string
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetLastNameOk() (*string, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *ContactEditable) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given string and assigns it to the LastName field.
func (o *ContactEditable) SetLastName(v string) {
	o.LastName = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *ContactEditable) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *ContactEditable) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *ContactEditable) SetEmail(v string) {
	o.Email = &v
}

// GetGender returns the Gender field value if set, zero value otherwise.
func (o *ContactEditable) GetGender() string {
	if o == nil || IsNil(o.Gender) {
		var ret string
		return ret
	}
	return *o.Gender
}

// GetGenderOk returns a tuple with the Gender field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetGenderOk() (*string, bool) {
	if o == nil || IsNil(o.Gender) {
		return nil, false
	}
	return o.Gender, true
}

// HasGender returns a boolean if a field has been set.
func (o *ContactEditable) HasGender() bool {
	if o != nil && !IsNil(o.Gender) {
		return true
	}

	return false
}

// SetGender gets a reference to the given string and assigns it to the Gender field.
func (o *ContactEditable) SetGender(v string) {
	o.Gender = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *ContactEditable) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *ContactEditable) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *ContactEditable) SetTitle(v string) {
	o.Title = &v
}

// GetFormal returns the Formal field value if set, zero value otherwise.
func (o *ContactEditable) GetFormal() bool {
	if o == nil || IsNil(o.Formal) {
		var ret bool
		return ret
	}
	return *o.Formal
}

// GetFormalOk returns a tuple with the Formal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetFormalOk() (*bool, bool) {
	if o == nil || IsNil(o.Formal) {
		return nil, false
	}
	return o.Formal, true
}

// HasFormal returns a boolean if a field has been set.
func (o *ContactEditable) HasFormal() bool {
	if o != nil && !IsNil(o.Formal) {
		return true
	}

	return false
}

// SetFormal gets a reference to the given bool and assigns it to the Formal field.
func (o *ContactEditable) SetFormal(v bool) {
	o.Formal = &v
}

// GetBirthdate returns the Birthdate field value if set, zero value otherwise.
func (o *ContactEditable) GetBirthdate() string {
	if o == nil || IsNil(o.Birthdate) {
		var ret string
		return ret
	}
	return *o.Birthdate
}

// GetBirthdateOk returns a tuple with the Birthdate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetBirthdateOk() (*string, bool) {
	if o == nil || IsNil(o.Birthdate) {
		return nil, false
	}
	return o.Birthdate, true
}

// HasBirthdate returns a boolean if a field has been set.
func (o *ContactEditable) HasBirthdate() bool {
	if o != nil && !IsNil(o.Birthdate) {
		return true
	}

	return false
}

// SetBirthdate gets a reference to the given string and assigns it to the Birthdate field.
func (o *ContactEditable) SetBirthdate(v string) {
	o.Birthdate = &v
}

// GetDayOfBirth returns the DayOfBirth field value if set, zero value otherwise.
func (o *ContactEditable) GetDayOfBirth() int32 {
	if o == nil || IsNil(o.DayOfBirth) {
		var ret int32
		return ret
	}
	return *o.DayOfBirth
}

// GetDayOfBirthOk returns a tuple with the DayOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetDayOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.DayOfBirth) {
		return nil, false
	}
	return o.DayOfBirth, true
}

// HasDayOfBirth returns a boolean if a field has been set.
func (o *ContactEditable) HasDayOfBirth() bool {
	if o != nil && !IsNil(o.DayOfBirth) {
		return true
	}

	return false
}

// SetDayOfBirth gets a reference to the given int32 and assigns it to the DayOfBirth field.
func (o *ContactEditable) SetDayOfBirth(v int32) {
	o.DayOfBirth = &v
}

// GetMonthOfBirth returns the MonthOfBirth field value if set, zero value otherwise.
func (o *ContactEditable) GetMonthOfBirth() int32 {
	if o == nil || IsNil(o.MonthOfBirth) {
		var ret int32
		return ret
	}
	return *o.MonthOfBirth
}

// GetMonthOfBirthOk returns a tuple with the MonthOfBirth field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetMonthOfBirthOk() (*int32, bool) {
	if o == nil || IsNil(o.MonthOfBirth) {
		return nil, false
	}
	return o.MonthOfBirth, true
}

// HasMonthOfBirth returns a boolean if a field has been set.
func (o *ContactEditable) HasMonthOfBirth() bool {
	if o != nil && !IsNil(o.MonthOfBirth) {
		return true
	}

	return false
}

// SetMonthOfBirth gets a reference to the given int32 and assigns it to the MonthOfBirth field.
func (o *ContactEditable) SetMonthOfBirth(v int32) {
	o.MonthOfBirth = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ContactEditable) GetAddress() ContactAddress {
	if o == nil || IsNil(o.Address) {
		var ret ContactAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ContactEditable) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given ContactAddress and assigns it to the Address field.
func (o *ContactEditable) SetAddress(v ContactAddress) {
	o.Address = &v
}

// GetLoyaltyPoints returns the LoyaltyPoints field value if set, zero value otherwise.
func (o *ContactEditable) GetLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LoyaltyPoints
}

// GetLoyaltyPointsOk returns a tuple with the LoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LoyaltyPoints) {
		return nil, false
	}
	return o.LoyaltyPoints, true
}

// HasLoyaltyPoints returns a boolean if a field has been set.
func (o *ContactEditable) HasLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LoyaltyPoints) {
		return true
	}

	return false
}

// SetLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LoyaltyPoints field.
func (o *ContactEditable) SetLoyaltyPoints(v map[string]int32) {
	o.LoyaltyPoints = &v
}

// GetLifetimeLoyaltyPoints returns the LifetimeLoyaltyPoints field value if set, zero value otherwise.
func (o *ContactEditable) GetLifetimeLoyaltyPoints() map[string]int32 {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		var ret map[string]int32
		return ret
	}
	return *o.LifetimeLoyaltyPoints
}

// GetLifetimeLoyaltyPointsOk returns a tuple with the LifetimeLoyaltyPoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetLifetimeLoyaltyPointsOk() (*map[string]int32, bool) {
	if o == nil || IsNil(o.LifetimeLoyaltyPoints) {
		return nil, false
	}
	return o.LifetimeLoyaltyPoints, true
}

// HasLifetimeLoyaltyPoints returns a boolean if a field has been set.
func (o *ContactEditable) HasLifetimeLoyaltyPoints() bool {
	if o != nil && !IsNil(o.LifetimeLoyaltyPoints) {
		return true
	}

	return false
}

// SetLifetimeLoyaltyPoints gets a reference to the given map[string]int32 and assigns it to the LifetimeLoyaltyPoints field.
func (o *ContactEditable) SetLifetimeLoyaltyPoints(v map[string]int32) {
	o.LifetimeLoyaltyPoints = &v
}

// GetStrictAttributes returns the StrictAttributes field value if set, zero value otherwise.
func (o *ContactEditable) GetStrictAttributes() map[string]ContactStrictAttribute {
	if o == nil || IsNil(o.StrictAttributes) {
		var ret map[string]ContactStrictAttribute
		return ret
	}
	return *o.StrictAttributes
}

// GetStrictAttributesOk returns a tuple with the StrictAttributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetStrictAttributesOk() (*map[string]ContactStrictAttribute, bool) {
	if o == nil || IsNil(o.StrictAttributes) {
		return nil, false
	}
	return o.StrictAttributes, true
}

// HasStrictAttributes returns a boolean if a field has been set.
func (o *ContactEditable) HasStrictAttributes() bool {
	if o != nil && !IsNil(o.StrictAttributes) {
		return true
	}

	return false
}

// SetStrictAttributes gets a reference to the given map[string]ContactStrictAttribute and assigns it to the StrictAttributes field.
func (o *ContactEditable) SetStrictAttributes(v map[string]ContactStrictAttribute) {
	o.StrictAttributes = &v
}

// GetCareOf returns the CareOf field value if set, zero value otherwise.
func (o *ContactEditable) GetCareOf() string {
	if o == nil || IsNil(o.CareOf) {
		var ret string
		return ret
	}
	return *o.CareOf
}

// GetCareOfOk returns a tuple with the CareOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetCareOfOk() (*string, bool) {
	if o == nil || IsNil(o.CareOf) {
		return nil, false
	}
	return o.CareOf, true
}

// HasCareOf returns a boolean if a field has been set.
func (o *ContactEditable) HasCareOf() bool {
	if o != nil && !IsNil(o.CareOf) {
		return true
	}

	return false
}

// SetCareOf gets a reference to the given string and assigns it to the CareOf field.
func (o *ContactEditable) SetCareOf(v string) {
	o.CareOf = &v
}

// GetAvatars returns the Avatars field value if set, zero value otherwise.
func (o *ContactEditable) GetAvatars() ContactAvatars {
	if o == nil || IsNil(o.Avatars) {
		var ret ContactAvatars
		return ret
	}
	return *o.Avatars
}

// GetAvatarsOk returns a tuple with the Avatars field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetAvatarsOk() (*ContactAvatars, bool) {
	if o == nil || IsNil(o.Avatars) {
		return nil, false
	}
	return o.Avatars, true
}

// HasAvatars returns a boolean if a field has been set.
func (o *ContactEditable) HasAvatars() bool {
	if o != nil && !IsNil(o.Avatars) {
		return true
	}

	return false
}

// SetAvatars gets a reference to the given ContactAvatars and assigns it to the Avatars field.
func (o *ContactEditable) SetAvatars(v ContactAvatars) {
	o.Avatars = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *ContactEditable) GetLanguages() ContactLanguages {
	if o == nil || IsNil(o.Languages) {
		var ret ContactLanguages
		return ret
	}
	return *o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetLanguagesOk() (*ContactLanguages, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *ContactEditable) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given ContactLanguages and assigns it to the Languages field.
func (o *ContactEditable) SetLanguages(v ContactLanguages) {
	o.Languages = &v
}

// GetMobileVerifiedAt returns the MobileVerifiedAt field value if set, zero value otherwise.
func (o *ContactEditable) GetMobileVerifiedAt() time.Time {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		var ret time.Time
		return ret
	}
	return *o.MobileVerifiedAt
}

// GetMobileVerifiedAtOk returns a tuple with the MobileVerifiedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetMobileVerifiedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.MobileVerifiedAt) {
		return nil, false
	}
	return o.MobileVerifiedAt, true
}

// HasMobileVerifiedAt returns a boolean if a field has been set.
func (o *ContactEditable) HasMobileVerifiedAt() bool {
	if o != nil && !IsNil(o.MobileVerifiedAt) {
		return true
	}

	return false
}

// SetMobileVerifiedAt gets a reference to the given time.Time and assigns it to the MobileVerifiedAt field.
func (o *ContactEditable) SetMobileVerifiedAt(v time.Time) {
	o.MobileVerifiedAt = &v
}

// GetExternalIds returns the ExternalIds field value if set, zero value otherwise.
func (o *ContactEditable) GetExternalIds() map[string]interface{} {
	if o == nil || IsNil(o.ExternalIds) {
		var ret map[string]interface{}
		return ret
	}
	return o.ExternalIds
}

// GetExternalIdsOk returns a tuple with the ExternalIds field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetExternalIdsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ExternalIds) {
		return map[string]interface{}{}, false
	}
	return o.ExternalIds, true
}

// HasExternalIds returns a boolean if a field has been set.
func (o *ContactEditable) HasExternalIds() bool {
	if o != nil && !IsNil(o.ExternalIds) {
		return true
	}

	return false
}

// SetExternalIds gets a reference to the given map[string]interface{} and assigns it to the ExternalIds field.
func (o *ContactEditable) SetExternalIds(v map[string]interface{}) {
	o.ExternalIds = v
}

// GetErConfidence returns the ErConfidence field value if set, zero value otherwise.
func (o *ContactEditable) GetErConfidence() ContactERConfidence {
	if o == nil || IsNil(o.ErConfidence) {
		var ret ContactERConfidence
		return ret
	}
	return *o.ErConfidence
}

// GetErConfidenceOk returns a tuple with the ErConfidence field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactEditable) GetErConfidenceOk() (*ContactERConfidence, bool) {
	if o == nil || IsNil(o.ErConfidence) {
		return nil, false
	}
	return o.ErConfidence, true
}

// HasErConfidence returns a boolean if a field has been set.
func (o *ContactEditable) HasErConfidence() bool {
	if o != nil && !IsNil(o.ErConfidence) {
		return true
	}

	return false
}

// SetErConfidence gets a reference to the given ContactERConfidence and assigns it to the ErConfidence field.
func (o *ContactEditable) SetErConfidence(v ContactERConfidence) {
	o.ErConfidence = &v
}

func (o ContactEditable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactEditable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Timezone) {
		toSerialize["timezone"] = o.Timezone
	}
	if !IsNil(o.Mobile) {
		toSerialize["mobile"] = o.Mobile
	}
	if !IsNil(o.MobileVerified) {
		toSerialize["mobile_verified"] = o.MobileVerified
	}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Gender) {
		toSerialize["gender"] = o.Gender
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	if !IsNil(o.Formal) {
		toSerialize["formal"] = o.Formal
	}
	if !IsNil(o.Birthdate) {
		toSerialize["birthdate"] = o.Birthdate
	}
	if !IsNil(o.DayOfBirth) {
		toSerialize["day_of_birth"] = o.DayOfBirth
	}
	if !IsNil(o.MonthOfBirth) {
		toSerialize["month_of_birth"] = o.MonthOfBirth
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.LoyaltyPoints) {
		toSerialize["loyalty_points"] = o.LoyaltyPoints
	}
	if !IsNil(o.LifetimeLoyaltyPoints) {
		toSerialize["lifetime_loyalty_points"] = o.LifetimeLoyaltyPoints
	}
	if !IsNil(o.StrictAttributes) {
		toSerialize["strict_attributes"] = o.StrictAttributes
	}
	if !IsNil(o.CareOf) {
		toSerialize["care_of"] = o.CareOf
	}
	if !IsNil(o.Avatars) {
		toSerialize["avatars"] = o.Avatars
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.MobileVerifiedAt) {
		toSerialize["mobile_verified_at"] = o.MobileVerifiedAt
	}
	if !IsNil(o.ExternalIds) {
		toSerialize["external_ids"] = o.ExternalIds
	}
	if !IsNil(o.ErConfidence) {
		toSerialize["er_confidence"] = o.ErConfidence
	}
	return toSerialize, nil
}

type NullableContactEditable struct {
	value *ContactEditable
	isSet bool
}

func (v NullableContactEditable) Get() *ContactEditable {
	return v.value
}

func (v *NullableContactEditable) Set(val *ContactEditable) {
	v.value = val
	v.isSet = true
}

func (v NullableContactEditable) IsSet() bool {
	return v.isSet
}

func (v *NullableContactEditable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactEditable(val *ContactEditable) *NullableContactEditable {
	return &NullableContactEditable{value: val, isSet: true}
}

func (v NullableContactEditable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactEditable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


